#ifndef EFL_GFX_IMAGE_IMPL_HH
#define EFL_GFX_IMAGE_IMPL_HH

#include "efl_gfx_image.eo.hh"

namespace efl { namespace gfx { 
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<bool>::type Image::smooth_scale_get() const
{
    Eina_Bool __return_value =  ::efl_gfx_image_smooth_scale_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::smooth_scale_set( ::efl::eolian::in_traits<bool>::type smooth_scale) const
{
     ::efl_gfx_image_smooth_scale_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(smooth_scale));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Gfx_Image_Scale_Type>::type Image::scale_type_get() const
{
    Efl_Gfx_Image_Scale_Type __return_value =  ::efl_gfx_image_scale_type_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Gfx_Image_Scale_Type>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::scale_type_set( ::efl::eolian::in_traits<Efl_Gfx_Image_Scale_Type>::type scale_type) const
{
     ::efl_gfx_image_scale_type_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Gfx_Image_Scale_Type,  ::efl::eolian::in_traits<Efl_Gfx_Image_Scale_Type>::type>(scale_type));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<double>::type Image::ratio_get() const
{
    double __return_value =  ::efl_gfx_image_ratio_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<double>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::border_get( ::efl::eolian::out_traits<int>::type l,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type t,  ::efl::eolian::out_traits<int>::type b) const
{
    int __out_param_l = {};
    int __out_param_r = {};
    int __out_param_t = {};
    int __out_param_b = {};
     ::efl_gfx_image_border_get(_eo_ptr(),
        & __out_param_l,
        & __out_param_r,
        & __out_param_t,
        & __out_param_b);
    ::efl::eolian::assign_out< ::efl::eolian::out_traits<int>::type, int>(l, __out_param_l);
    ::efl::eolian::assign_out< ::efl::eolian::out_traits<int>::type, int>(r, __out_param_r);
    ::efl::eolian::assign_out< ::efl::eolian::out_traits<int>::type, int>(t, __out_param_t);
    ::efl::eolian::assign_out< ::efl::eolian::out_traits<int>::type, int>(b, __out_param_b);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::border_set( ::efl::eolian::in_traits<int>::type l,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type t,  ::efl::eolian::in_traits<int>::type b) const
{
     ::efl_gfx_image_border_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(l),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(r),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(t),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(b));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<double>::type Image::border_scale_get() const
{
    double __return_value =  ::efl_gfx_image_border_scale_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<double>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::border_scale_set( ::efl::eolian::in_traits<double>::type scale) const
{
     ::efl_gfx_image_border_scale_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<double,  ::efl::eolian::in_traits<double>::type>(scale));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Gfx_Border_Fill_Mode>::type Image::border_center_fill_get() const
{
    Efl_Gfx_Border_Fill_Mode __return_value =  ::efl_gfx_image_border_center_fill_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Gfx_Border_Fill_Mode>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::border_center_fill_set( ::efl::eolian::in_traits<Efl_Gfx_Border_Fill_Mode>::type fill) const
{
     ::efl_gfx_image_border_center_fill_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Gfx_Border_Fill_Mode,  ::efl::eolian::in_traits<Efl_Gfx_Border_Fill_Mode>::type>(fill));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Size2D>::type Image::image_size_get() const
{
    Eina_Size2D __return_value =  ::efl_gfx_image_size_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Size2D>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Gfx_Image_Content_Hint>::type Image::content_hint_get() const
{
    Efl_Gfx_Image_Content_Hint __return_value =  ::efl_gfx_image_content_hint_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Gfx_Image_Content_Hint>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::content_hint_set( ::efl::eolian::in_traits<Efl_Gfx_Image_Content_Hint>::type hint) const
{
     ::efl_gfx_image_content_hint_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Gfx_Image_Content_Hint,  ::efl::eolian::in_traits<Efl_Gfx_Image_Content_Hint>::type>(hint));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Gfx_Image_Scale_Hint>::type Image::scale_hint_get() const
{
    Efl_Gfx_Image_Scale_Hint __return_value =  ::efl_gfx_image_scale_hint_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Gfx_Image_Scale_Hint>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::scale_hint_set( ::efl::eolian::in_traits<Efl_Gfx_Image_Scale_Hint>::type hint) const
{
     ::efl_gfx_image_scale_hint_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Gfx_Image_Scale_Hint,  ::efl::eolian::in_traits<Efl_Gfx_Image_Scale_Hint>::type>(hint));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Error>::type Image::image_load_error_get() const
{
    Eina_Error __return_value =  ::efl_gfx_image_load_error_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Error>::type>(__return_value);
}
#endif
} } 
namespace eo_cxx {
namespace efl { namespace gfx { 
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<bool>::type Image::smooth_scale_get() const
{
    Eina_Bool __return_value =  ::efl_gfx_image_smooth_scale_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<bool>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::smooth_scale_set( ::efl::eolian::in_traits<bool>::type smooth_scale) const
{
     ::efl_gfx_image_smooth_scale_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Eina_Bool,  ::efl::eolian::in_traits<bool>::type>(smooth_scale));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Gfx_Image_Scale_Type>::type Image::scale_type_get() const
{
    Efl_Gfx_Image_Scale_Type __return_value =  ::efl_gfx_image_scale_type_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Gfx_Image_Scale_Type>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::scale_type_set( ::efl::eolian::in_traits<Efl_Gfx_Image_Scale_Type>::type scale_type) const
{
     ::efl_gfx_image_scale_type_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Gfx_Image_Scale_Type,  ::efl::eolian::in_traits<Efl_Gfx_Image_Scale_Type>::type>(scale_type));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<double>::type Image::ratio_get() const
{
    double __return_value =  ::efl_gfx_image_ratio_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<double>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::border_get( ::efl::eolian::out_traits<int>::type l,  ::efl::eolian::out_traits<int>::type r,  ::efl::eolian::out_traits<int>::type t,  ::efl::eolian::out_traits<int>::type b) const
{
    int __out_param_l = {};
    int __out_param_r = {};
    int __out_param_t = {};
    int __out_param_b = {};
     ::efl_gfx_image_border_get(_eo_ptr(),
        & __out_param_l,
        & __out_param_r,
        & __out_param_t,
        & __out_param_b);
    ::efl::eolian::assign_out< ::efl::eolian::out_traits<int>::type, int>(l, __out_param_l);
    ::efl::eolian::assign_out< ::efl::eolian::out_traits<int>::type, int>(r, __out_param_r);
    ::efl::eolian::assign_out< ::efl::eolian::out_traits<int>::type, int>(t, __out_param_t);
    ::efl::eolian::assign_out< ::efl::eolian::out_traits<int>::type, int>(b, __out_param_b);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::border_set( ::efl::eolian::in_traits<int>::type l,  ::efl::eolian::in_traits<int>::type r,  ::efl::eolian::in_traits<int>::type t,  ::efl::eolian::in_traits<int>::type b) const
{
     ::efl_gfx_image_border_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(l),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(r),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(t),
         ::efl::eolian::convert_to_c<int,  ::efl::eolian::in_traits<int>::type>(b));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<double>::type Image::border_scale_get() const
{
    double __return_value =  ::efl_gfx_image_border_scale_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<double>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::border_scale_set( ::efl::eolian::in_traits<double>::type scale) const
{
     ::efl_gfx_image_border_scale_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<double,  ::efl::eolian::in_traits<double>::type>(scale));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Gfx_Border_Fill_Mode>::type Image::border_center_fill_get() const
{
    Efl_Gfx_Border_Fill_Mode __return_value =  ::efl_gfx_image_border_center_fill_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Gfx_Border_Fill_Mode>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::border_center_fill_set( ::efl::eolian::in_traits<Efl_Gfx_Border_Fill_Mode>::type fill) const
{
     ::efl_gfx_image_border_center_fill_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Gfx_Border_Fill_Mode,  ::efl::eolian::in_traits<Efl_Gfx_Border_Fill_Mode>::type>(fill));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Size2D>::type Image::image_size_get() const
{
    Eina_Size2D __return_value =  ::efl_gfx_image_size_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Size2D>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Gfx_Image_Content_Hint>::type Image::content_hint_get() const
{
    Efl_Gfx_Image_Content_Hint __return_value =  ::efl_gfx_image_content_hint_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Gfx_Image_Content_Hint>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::content_hint_set( ::efl::eolian::in_traits<Efl_Gfx_Image_Content_Hint>::type hint) const
{
     ::efl_gfx_image_content_hint_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Gfx_Image_Content_Hint,  ::efl::eolian::in_traits<Efl_Gfx_Image_Content_Hint>::type>(hint));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Efl_Gfx_Image_Scale_Hint>::type Image::scale_hint_get() const
{
    Efl_Gfx_Image_Scale_Hint __return_value =  ::efl_gfx_image_scale_hint_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Efl_Gfx_Image_Scale_Hint>::type>(__return_value);
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<void>::type Image::scale_hint_set( ::efl::eolian::in_traits<Efl_Gfx_Image_Scale_Hint>::type hint) const
{
     ::efl_gfx_image_scale_hint_set(_eo_ptr(),
         ::efl::eolian::convert_to_c<Efl_Gfx_Image_Scale_Hint,  ::efl::eolian::in_traits<Efl_Gfx_Image_Scale_Hint>::type>(hint));
}
#endif
#ifdef EFL_BETA_API_SUPPORT
inline ::efl::eolian::return_traits<Eina_Error>::type Image::image_load_error_get() const
{
    Eina_Error __return_value =  ::efl_gfx_image_load_error_get(_eo_ptr());
    return ::efl::eolian::convert_to_return< ::efl::eolian::return_traits<Eina_Error>::type>(__return_value);
}
#endif
inline efl::gfx::Image::operator ::efl::gfx::Image() const { return *static_cast< ::efl::gfx::Image const*>(static_cast<void const*>(this)); }
inline efl::gfx::Image::operator ::efl::gfx::Image&() { return *static_cast< ::efl::gfx::Image*>(static_cast<void*>(this)); }
inline efl::gfx::Image::operator ::efl::gfx::Image const&() const { return *static_cast< ::efl::gfx::Image const*>(static_cast<void const*>(this)); }
} } }
#endif
